<?php


namespace app\cxinv\model;


use think\Model;
use think\model\concern\SoftDelete;
class PaymentOrder extends Base{
    use SoftDelete;
    protected $createTime='createTime';
    protected $updateTime='updateTime';
    protected $deleteTime='delete_time';
    //CREATE TABLE `cfp_payment_order` (
    //  `id` int(11) NOT NULL AUTO_INCREMENT,
    //  `dzNo` varchar(255) NOT NULL COMMENT '对账付款申请编号',
    //  `cgdNo` varchar(255) NOT NULL COMMENT '关联采购单编号',
    //  `rela_fee` decimal(18,2) NOT NULL COMMENT '关联金额',
    //  `status` tinyint(3) NOT NULL COMMENT '状态 0 关联中 1 已付款 2 解除付款 3 取消付款',
    //  `createTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
    //  `updateTime` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
    //  `delete_time` datetime DEFAULT NULL,
    //  PRIMARY KEY (`id`)
    //) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='付款申请关联订单数据';
    protected $schema=[
        'id'=>'int',
        'dzNo'=>'string',
        'cgdNo'=>'string',
        'rela_fee'=>'decimal',
        'status'=>'tinyint',
        'createTime'=>'datetime',
        'updateTime'=>'datetime',
        'delete_time'=>'datetime'
    ];
        //状态 0 关联中 1 已付款 2 解除付款 3 取消付款',
    public static function onAfterWrite(Model $model) : void{
         $cgdNo = $model->cgdNo;
         $status = $model->status;
         $cgdinfo = CgdInfo::where(["sequenceNo"=>$cgdNo,"is_del"=>0,"status"=>1])->findOrEmpty();
         if($cgdinfo->isEmpty()) return;
         switch ($status){
             case 0:
                 $cgdinfo->wpay_fee= $cgdinfo->wpay_fee-$model->rela_fee;
                 break;
             case 1:
                 $cgdinfo->apay_fee= $cgdinfo->apay_fee+$model->rela_fee;
                 break;
             case 2:
                 $cgdinfo->apay_fee= $cgdinfo->apay_fee-$model->rela_fee;
                 $cgdinfo->wpay_fee= $cgdinfo->wpay_fee+$model->rela_fee;
                 break;
             case 3:
                $cgdinfo->wpay_fee= $cgdinfo->wpay_fee+$model->rela_fee;
                break;
                default:
                 return;
         }
         $cgdinfo->save();
    }
}